float blury[3 * 2046 * 2048];

__device__ void kernel_blur (float blury[3 * 2046 * 2048], float img[3*2048*2048]) { |\label{line:cuda-blur:kernel-start}|
    int tx = blockIdx.x;
    int ty = blockIdx.y;
    int tz = blockIdx.z;

    __shared__ float blurx[32][10]; |\label{line:cuda-blur:scratchpad}|
    int x = threadIdx.x;
    int y = threadIdx.y;
    int c = threadIdx.z;

    /* Tile of function blurx. */
    blurx[x][y + 1] = (img[c][tx*32 + x-1][ty*10+y] + |\label{line:cuda-blur:blurx}|
                                img[c][tx*32+x  ][ty*10+y] + 
                                img[c][tx*32+x+1][ty*10+y])/3.0;     
    __syncthreads (); |\label{line:cuda-blur:syncthreads}|
    /* Tile of function blury. */
    blury[c][x][y] = (blurx[tx * 32 + x][ty * 10 + y - 1] +
                            blurx[tx * 32 + x][ty * 10 + y] +
                            blurx[tx * 32 + x][ty * 10 + y + 1]) / 3.0;
} |\label{line:cuda-blur:kernel-end}|

kernel_blur <<<(2048/8, 2048/32, 3), (10, 32, 1)>>> (blury, img); |\label{line:cuda-blur:kernel-call}|
