R,C = Parameter(Int,"R"),Parameter(Int,"C") |\label{line:blur:parameter}|

# Vars
x = Variable(Int,"x")
y = Variable(Int,"y")
c = Variable(Int,"c")

# Input Image
img = Image(Float,"img",[3,R+2,C+2]) |\label{line:blur:image}|

# Intervals
cr = Interval(Int,0,2) |\label{line:blur:intervalstart}|
xrow,xcol = Interval(Int,1,R),Interval(Int,0,C+1) 
yrow,ycol = Interval(Int,1,R),Interval(Int,1,C) |\label{line:blur:intervalend}|

cond = Condition(x,'>=',1) & Condition(x,'<=',R) & 
       Condition(y,'<=',C) & Condition(y,'>=',1)

blurx = Function(([c,x,y],[cr,xrow,xcol]),|\label{line:blur:blurxstart}|
		 Float,"blurx") 
blurx.defn = [Case(cond,(img(c,x-1,y) + img(c,x,y) +
                         img(c,x+1,y))/3)] |\label{line:blur:blurxend}|
blury = Function(([c,x,y],[cr,yrow,ycol]),
		 Float,"blury") |\label{line:blur:blurystart}|
blury.defn = [Case(cond,(blurx(c,x,y-1) + 
              blurx(c,x,y) + blurx(c,x,y+1))/3)] |\label{line:blur:bluryend}|
